// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors
 */
// </header>

package fr.unicaen.openmap.gui.menu;

import fr.unicaen.openmap.util.AbstractTextFormatter;
import javax.swing.JMenu;

/**
 *
 * @author jchauvea
 */
public class SaveAsMenuJWS extends com.bbn.openmap.gui.menu.SaveAsMenu {

    public SaveAsMenuJWS() {
	this("Sauvegarder en tant que");
    }

    public SaveAsMenuJWS(String title) {
	super(title);
        //add(new SaveAsJpegMenuItem());
        //add(new SaveAsGifMenuItem());
	//addKmlMenuItem(this);
    }

    /**
     * This method uses a real SVG formatter, not batik with raster export.
     */
    public void addSVGMenuItem(JMenu menu) {
	AbstractTextFormatter obj = new fr.unicaen.openmap.util.SVGFormatter();
	menu.add(new SaveAsTextMenuItem("Real SVG", (AbstractTextFormatter) obj));
    }

    public void addKmlMenuItem(JMenu menu) {
	AbstractTextFormatter obj = new fr.unicaen.openmap.dataStorage.kml.KMLExporter();
	menu.add(new SaveAsTextMenuItem("KML", (AbstractTextFormatter) obj));
    }
}
