/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.chartLayer;

import com.bbn.openmap.omGraphics.OMGraphicList;
import fr.unicaen.openmap.dataStorage.MonoValuedFilterDataStorage;
import fr.unicaen.openmap.dataStorage.DataStorage;
import fr.unicaen.openmap.dataStorage.gui.AdaptorButtonArray;
import fr.unicaen.openmap.layer.chartLayer.chart.Chart;
import fr.unicaen.openmap.layer.chartLayer.chart.ThemaMapChartFactory;
import fr.unicaen.openmap.layer.dataDisplayLayer.SimpleDataDisplayLayer;
import fr.unicaen.openmap.layer.dataDisplayLayer.gui.SimplePalette;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.Colorizer;
import java.awt.BorderLayout;
import java.awt.Component;
import java.util.ArrayList;
import java.util.Properties;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import org.jfree.chart.ChartPanel;

/**
 * ThemaMap Layer for chart construction from data source
 * @author jchauvea
 */
public class ChartLayer extends SimpleDataDisplayLayer {

//    public String getName(int i) {
//        return i >= 0 && i < colorDataColumnNames.length ? colorDataColumnNames[i] : "";
//    }

    /*public void setCategories(String[] names) {
        setColorDataColumnNames(names);
    }

    public void setSeries(){String names){


    }}*/

//    private void setColorDataColumnNames(String[] names) {
//        colorDataColumnNames = names;
//    }

    /*public enum chartType {

        BAR, PIE, XY
    };
    private chartType type = chartType.PIE;*/
    private ArrayList<String> xNames = new ArrayList<String>();
    private Chart chart;
    private boolean active = false;
    private SimplePalette gui;
    private JPanel panSource;
    private Component panelContentSource;
    private JPanel panData;
    protected Colorizer colorizer = new Colorizer();
    protected String chartTitle = "";
    public final static String ChartTitlePropertyString = "chartTitle";
    protected String[] categories = new String[0];
    protected String[] series = new String[0];
    private ChartPanel chartGUI;
    private ChartLayerPanel chartLayerPanel;

    public ChartLayer() {
        setMouseModeIDsForEvents(new String[]{"Gestures"});
        setAddToBeanContext(true);
    }

    public void setChart(Chart chart){this.chart = chart;}

    public Chart getChart(){return chart;}



    public OMGraphicList generateGraphics() {
//        JFreeChart chart = null;
//        switch (type) {
//            case BAR:
//                break;
//            case XY:
//                break;
//            case PIE:
//                DefaultPieDataset dataset = new DefaultPieDataset();
//                /*for (String x : xNames) {
//                dataset.setValue(x, );
//                }*/
//                dataset.setValue("Section 1", 23.3);
//                dataset.setValue("Section 2", 56.5);
//                dataset.setValue("Section 3", 43.3);
//                dataset.setValue("Section 4", 11.1);
//                chart = ChartFactory.createPieChart("Chart 1", dataset, false, false, false);
//                break;
//
//        }
       // chart.createBufferedImage(800, 600);
       /* OMGraphicList omgl = new OMGraphicList();
        if(chart == null)
            return omgl;
        omgl.add(new OMRaster(0, 0, chart.getImage(getWidth(), getHeight())));
        omgl.generate(getProjection());
        return omgl;*/
        return null;
    }

    @Override
    public Component getGUI() {
        if (gui == null) {
            gui = new SimplePalette();
            panSource = new JPanel(new BorderLayout());
            JButton[] adaptorButtons = new AdaptorButtonArray(this).getButtons();
            JToolBar toolSource = new JToolBar();
            for (JButton b : adaptorButtons) {
                toolSource.add(b);
            }
            panSource.add(toolSource, BorderLayout.NORTH);
            panelContentSource = super.getGUI();
            panSource.add(panelContentSource, BorderLayout.CENTER);
            gui.getTabs().addTab("Source", panSource);
            panData = new JPanel();
            panData.add(dataStorageIterator.getDataGUI());
            gui.getTabs().addTab("Données", panData);
            chartLayerPanel = new ChartLayerPanel(this);
            gui.getTabs().addTab("Représentation", chartLayerPanel);
        }
        return gui;
    }

    @Override
    public Properties getPropertyInfo(Properties info) {
        return super.getPropertyInfo(info);
        /*PropUtils.setI18NPropertyInfo(i18n, info, ChartLayer.class,
        "chartTitle",
        i18n.get(ChartLayer.class, "chartTitle", "Chart Title"),
        i18n.get(ChartLayer.class, "chartTitle", "Chart Title"),
        null);

        info.put(initPropertiesProperty,
        ChartTitlePropertyString);
        return info;*/
    }

    @Override
    public void setProperties(String prefix, Properties properties) {
        super.setProperties(prefix, properties);
    }

    @Override
    public Properties getProperties(Properties properties) {
        properties = super.getProperties(properties);
        return properties;
    }

    @Override
    public synchronized OMGraphicList prepare() {
        OMGraphicList omgl = null;

        if (getProjection() == null || !active) {
            return null;
        }

        setList(null);
        omgl = generateGraphics();
        setVisible(true);
        setList(omgl);
        return omgl;
    }

    public void setActive(boolean b) {
        active = b;
        doPrepare();
    }


    public Colorizer getColorizer() {
        return colorizer;
    }

//    protected ArrayList<String> getNoColorDataColumnNames() {
//        ArrayList<String> names = new ArrayList<String>();
//        for (String name : dataStorageIterator.getDataColumnNames()) {
//            if (!isAColorDataColumnNames(name)) {
//                names.add(name);
//            }
//
//        }
//        return names;
//    }
//
//    private boolean isAColorDataColumnNames(String columnName) {
//        for (int i = 0; i <
//                colorDataColumnNames.length; i++) {
//            if (colorDataColumnNames[i].equals(columnName)) {
//                return true;
//            }
//
//        }
//        return false;
//    }

    @Override
    protected void refreshDSGUI() {
        if (dataStorageIterator != null && dataStorageIterator.getGUI() != null) {
            // Data GUI
            if (dataStorageIterator.getDataGUI() != null) {
                panData.removeAll();
                panData.add(dataStorageIterator.getDataGUI());
            }
            //configPanel.setDataStorageIterator(dataStorageIterator);
            // refresh DataStorage GUI
            ((JComponent)panelContentSource).removeAll();
            ((JComponent)panelContentSource).add(super.getGUI());
            panSource.add(panelContentSource, BorderLayout.CENTER);
            panSource.updateUI();
        }
    }

    public void buildChartAndDrawFromParameters(Chart.ChartType ct,
            String name,
            String x,
            String y,
            String[] cat,
            String[] ser){
        
        switch(ct){
            case BAR:
        setChart(ThemaMapChartFactory.buildBarChart(dataStorageIterator,
                name,
                x,
                y,
                cat,
                ser));
            case XY:
              setChart(ThemaMapChartFactory.buildXYChart(dataStorageIterator,
                name,
                x,
                y,
                cat,
                ser));
        }
        if(chartGUI == null)
            chartGUI = new ChartPanel(chart.getJFreeChart());
        else
            chartGUI.setChart(chart.getJFreeChart());
        chartGUI.updateUI();

    }

    @Override
    public void dataStorageEvent(DataStorage source) {
        refreshGUI();
    }

    @Override
    public void refreshGUI(){
        if(chartLayerPanel!=null)
            chartLayerPanel.refreshGUI();
    }
    
    public JComponent getChartGUI(){
        if(chartGUI == null){
            JPanel p = new JPanel();
            p.add(new JLabel(" - Aucun graphique de configuré - "));
            return p;
        }
        return chartGUI;
    }

    public void animationModeChanged(MonoValuedFilterDataStorage ads) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }
}
