// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.tips;


//author : Yannick Lange, ylange@etu.info.unicaen.fr, DESS NAPI, juin-septembre 2003.
@Deprecated
public class WithProperties
{
    //used to parse legend title
    public static final char ENDLINE = '\n'; 
    public static final char SEPARATOR = '@'; //to replace ENDLINE in properties file, when save...

    //when String (on many lines) is saved (by getProperties), 
    //the setProperties is not able to reload all lines -because any property is defined on one line !-
    //so, when save happens, String must become one line
    //when reload, this line re-become many line
    //pb with separator : choose one char not present in normal text
    public static String modify(String string, char oldChar, char newChar)
    {
	return string.replace(oldChar, newChar);
    }    

    public static String save(String string)
    {
	return modify(string, ENDLINE, SEPARATOR);
    }

    public static String load(String string)
    {
	return modify(string, SEPARATOR, ENDLINE);
    }
}
