// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.gml.gui;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
/** @deprecated */
public class GMLSaveFileChooser extends JFileChooser{

    public static final String GML = "gml";
    public static final String GMZ = "gmz";
	
	public GMLSaveFileChooser(String path){
		super(path);
		FileNameExtensionFilter filter = new FileNameExtensionFilter(
		        "GML files", GML);
        FileNameExtensionFilter filterz = new FileNameExtensionFilter(
		        "Compressed GML files", GMZ);
        setFileFilter(filter);
        addChoosableFileFilter(filterz);
        addChoosableFileFilter(filter);

	}
	
}
