// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Toolkit;

import fr.unicaen.openmap.util.Util;

public class NavigatePanel extends com.bbn.openmap.gui.NavigatePanel{

	 public NavigatePanel() {
		 super();

		 setOpaque(false);
		 
		 seButton.setIcon(Util.loadIcon("corner.png"));
	 
		 sButton.setIcon(Util.loadIcon("bottom.png"));
		 
		 swButton.setIcon(Util.loadIcon("corner.png"));
		 
		 wButton.setIcon(Util.loadIcon("left.png"));
	 
		 nwButton.setIcon(Util.loadIcon("corner.png"));
	 
		 nButton.setIcon(Util.loadIcon("top.png"));
		 
		 neButton.setIcon(Util.loadIcon("corner.png"));
		 
		 eButton.setIcon(Util.loadIcon("right.png"));
		 
		 cButton.setIcon(Util.loadIcon("center.png"));

		 setPreferredSize(new Dimension(60,60));
 
	 }
	 
	 public void paintComponent(Graphics arg0) {
	        arg0.drawImage(Util.loadIcon("circle.png").getImage(),0,0,null);
	    }
	
	
}
