/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.chartLayer.chart;

import fr.unicaen.openmap.dataStorage.DataStorageIterator;

/**
 *
 * @author jchauvea
 */
public class ThemaMapChartFactory {


    public static Chart buildChart(Chart.ChartType c, DataStorageIterator dsi, String name, String xName, String yName, String[] categories, String[] series) {
        switch (c) {
            case BAR:
                return buildBarChart(dsi, name, xName, yName, categories, series);
        }
        return null;

    }

    public static Chart buildBarChart(DataStorageIterator dsi, String name, String xName, String yName,  String[] categories, String[] series) {

        return new BarChart(dsi, name, xName, yName, categories, series);
    }

    public static Chart buildXYChart(DataStorageIterator dsi, String name, String xName, String yName,  String[] categories, String[] series) {

        return new XYChart(dsi, name, xName, yName, categories, series);
    }
}
