/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.unicaen.openmap.layer.chartLayer.chart;

import fr.unicaen.openmap.dataStorage.DataObject;
import fr.unicaen.openmap.dataStorage.DataStorageIterator;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import java.awt.image.BufferedImage;
import java.util.HashMap;
import javax.swing.JComponent;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 *
 * @author jchauvea
 */
public class XYChart extends Chart{

    private XYSeriesCollection data;



    public XYChart(DataStorageIterator dsi, String name, String xName, String yName, String[] categories, String[] series){
        super(dsi, name, xName, yName, categories, series);
    }

    protected void buildDataSet(DataStorageIterator dsi){
        data = new XYSeriesCollection();
        dsi.reset();
        //XYSeries series = new XYSeries("");
        XYSeries[] xyseries = new XYSeries[nbSeries];
        while(dsi.hasNext()){
            DataObject dataObject = dsi.next();
            for(int i = 0; i < series.length; i++){
                double x = Double.parseDouble((String)dataObject.getData(categories[i]));
                double y = Double.parseDouble((String)dataObject.getData(series[i]));

            }
             /*for(int i = 0; i < typeColunms.length; i++){
                int x = Integer.parseInt(typeColunms[i]);
                int y = Integer.parseInt((String)dataObject.getData(typeColunms[i]));
                series.add(x, y);           
             }*/

             //series.add(x, y);
        }
        //data.addSeries(series);
        /*for(int i = 0; i < nbSeries; i++){
            XYSeries series = new XYSeries(typeColunms[i]);

        }*/

//        HashMap<String, XYSeries> seriesMap = new HashMap<String, XYSeries>();
//        for(int i = 0; i < nbSeries; i++){
//            XYSeries series = new XYSeries(xColumns[i]);
//            seriesMap.put(xColumns[i], series);
//            //String xName = xColumns[i];
//            //series.add();
//        }
//        while(dsi.hasNext()){
//            DataObject dataObject = dsi.next();
//
//
//        }
    }

    @Override
    public BufferedImage getImage(int w, int h) {
        JFreeChart chart = ChartFactory.createXYLineChart(name, xName, yName, data,
                PlotOrientation.VERTICAL, true, true, true );
        return chart.createBufferedImage(w, h);
    }

    @Override
    public JFreeChart getJFreeChart() {
        return ChartFactory.createXYLineChart(name, xName, yName, data,
                PlotOrientation.VERTICAL, true, true, true );
    }

}
