/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import com.bbn.openmap.Environment;
import com.bbn.openmap.omGraphics.OMColorChooser;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.AttributesNames;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Histogram;
import fr.unicaen.openmap.util.gui.ComponentSizer;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 *Panel for curve representation
 * @author jchauvea
 */
public class CurveColorScalePanel extends AttributesColorScalePanel {

    public CurveColorScalePanel(ColorScale colorScale, AttributesNames attributesNames) {
        super(colorScale, attributesNames);
        JPanel pAxes = new JPanel();
        add(pAxes, BorderLayout.SOUTH);
        pAxes.add(new JLabel(i18n.get(AttributesColorScalePanel.class, "axes", "Axes")));
        //pAxes.add(((Histogram) attributesNames).createStrokeEditor());
    }

    @Override
    public void createOptionPanel() {
        super.createOptionPanel();
        panOption.removeAll();
        JPanel pNumber = new JPanel();
        pNumber.add(new JLabel(i18n.get(ColorScalePanel.class, "class_number", "Class number")));
        pNumber.add(colorNumber);
        panOption.add(pNumber);
        JPanel pColor = new JPanel();
        pColor.add(new JLabel(i18n.get(ColorScalePanel.class, "color", "Color")));

    }

    @Override
    public void createColorScalePanel() {

        if (panColorScale == null) {
            panColorScale = new JPanel(new BorderLayout());
        }
        Box pCombos = Box.createVerticalBox();
        colorCombos = new JComboBox[colorScale.getColorNumber()];
        colorButtons.clear();
        if (available == null) {
            available = new Vector<String>();
        }
        //Dimension buttonsDimension = new Dimension(20, 20);
        JPanel pTop = new JPanel();
        pTop.add(new JLabel(i18n.get(AttributesColorScalePanel.class, "attributes", "Attributes to represent")));
        panColorScale.add(pTop, BorderLayout.NORTH);
        //System.out.println(attributesNames.getName(0));
        for (int i = 0; i < colorScale.getColorNumber(); i++) {
            // System.out.println(i);
            // System.out.println("a-"+attributesNames.getName(i));
            //ColorScaleButton b = new ColorScaleButton(this, i);
            //colorButtons.add(b);
            //ComponentSizer.fixComponentSize(b, buttonsDimension);
            /*colorButtons[i].setPreferredSize(buttonsDimension);
            colorButtons[i].setMaximumSize(buttonsDimension);*/
            //b.setBackground(colorScale.getColor(i));
            colorCombos[i] = new JComboBox();
            //int index = -1;
            //System.out.println("b-"+attributesNames.getName(i));
            for (int j = 0; j < available.size(); j++) {
                colorCombos[i].addItem(available.get(j));
//                System.out.println(attributesNames.getName(i) + " ; " + available.get(j));
//                if(attributesNames.getName(i).equals(available.get(j)))
//                    index = j;
            }
            //System.out.println(attributesNames);
            if (!attributesNames.getName(i).equals("")) {
                colorCombos[i].addItem(attributesNames.getName(i));
                colorCombos[i].setSelectedItem(attributesNames.getName(i));
            }

            ComponentSizer.fixComponentSize(colorCombos[i], new Dimension(100, 20));
            /*colorCombos[i].setPreferredSize(new Dimension(100, 20));
            colorCombos[i].setMaximumSize(new Dimension(100, 20));*/
            ItemListener itml = new ItemListener() {

                public void itemStateChanged(ItemEvent ie) {
                    refresh();
                }
            };

            colorCombos[i].addItemListener(itml);
            JPanel p = new JPanel();
            //p.add(b);
            p.add(colorCombos[i]);
            p.setBorder(BorderFactory.createEmptyBorder(-5, 0, -5, 0));
            pCombos.add(p);
        }
        panColorScale.add(pCombos, BorderLayout.CENTER);
        updateUI();
    }

//    class CurveScaleColorButton extends JButton {
//
//        public CurveScaleColorButton() {
//            ComponentSizer.fixComponentSize(this, new Dimension(20, 20));
//            addActionListener(new ActionListener() {
//
//                public void actionPerformed(ActionEvent arg0) {
//                    OMColorChooser.showDialog(
//                            CurveScaleColorButton.this,
//                            Environment.getI18n().get(ColorizerColorScalePanel.class, "colorChooser", "Choose a color..."), getBackground());
//                }
//            });
//
//        }
//    }
}
