// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.test;

import fr.unicaen.openmap.dataStorage.BoundingBox;

public class TestBoundingBox {

    public static void main (String argv[]) {
	BoundingBox area,poly;

	area = new BoundingBox (0, 50, 50, 0);
	
	poly = new BoundingBox(10, 10, 20, -10);
	System.out.println("" + poly + area + poly.intersects(area));

	poly = new BoundingBox (10, 60, 20, -5);
	System.out.println("" + poly + area + poly.intersects(area));
	
	poly = new BoundingBox (-5, 60, 50, -5);
	System.out.println("" + poly + area + poly.intersects(area));
	
	poly = new BoundingBox (-5, 20, 60, 5);
	System.out.println("" + poly + area + poly.intersects(area));
    }
}
